package com.ynet.life.sujrb.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.data.IndexedCollection;
import com.ynet.gene.data.KeyedCollection;
import com.ynet.life.base.LifeAction;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;

/* loaded from: com_ynet_life_sujrb_action.jar:com/ynet/life/sujrb/action/MergeIcollWithPrimaryKey.class */
public class MergeIcollWithPrimaryKey extends LifeAction {
    private String primaryKey;
    private String icollNameForA;
    private String icollNameForB;
    private String mergeField;
    private static final String FIELD_SEQARATOR = "||";

    public String execute(Context context) throws GENEException {
        IndexedCollection icollA = context.getDataElement(this.icollNameForA);
        IndexedCollection icollB = context.getDataElement(this.icollNameForB);
        HashMap<String, KeyedCollection> primaryMap = new HashMap<>();
        for (int i = 0; i < icollA.size(); i++) {
            KeyedCollection kcollA = (KeyedCollection) icollA.get(i);
            String primaryKeyValueA = (String) kcollA.getDataValue(this.primaryKey);
            primaryMap.put(primaryKeyValueA, kcollA);
        }
        for (int i2 = 0; i2 < icollB.size(); i2++) {
            KeyedCollection kcollB = (KeyedCollection) icollB.get(i2);
            String primaryKeyValueB = (String) kcollB.getDataValue(this.primaryKey);
            KeyedCollection kcollA2 = primaryMap.get(primaryKeyValueB);
            if (kcollA2 != null) {
                mergeKcoll(kcollA2, kcollB);
            }
        }
        icollA.removeAll();
        Iterator iter = primaryMap.keySet().iterator();
        while (iter.hasNext()) {
            icollA.addDataElement(primaryMap.get(iter.next()));
        }
        context.put(this.icollNameForA, icollA);
        return "0";
    }

    private void mergeKcoll(KeyedCollection kcollA, KeyedCollection kcollB) throws GENEException {
        if (this.mergeField != null) {
            StringTokenizer token = new StringTokenizer(this.mergeField, FIELD_SEQARATOR);
            while (token.hasMoreTokens()) {
                String field = token.nextToken();
                mergeKcoll(field, kcollA, kcollB);
            }
            return;
        }
        for (String field2 : kcollB.keySet()) {
            mergeKcoll(field2, kcollA, kcollB);
        }
    }

    private void mergeKcoll(String field, KeyedCollection kcollA, KeyedCollection kcollB) throws GENEException {
        if (field.equals(this.primaryKey)) {
            return;
        }
        if (!kcollA.containsKey(field) || kcollA.getDataValue(field) == null) {
            String fieldValueB = (String) kcollB.getDataValue(field);
            kcollA.put(field, fieldValueB);
        }
    }

    public String getPrimaryKey() {
        return this.primaryKey;
    }

    public void setPrimaryKey(String primaryKey) {
        this.primaryKey = primaryKey;
    }

    public void setIcollNameForA(String icollNameForA) {
        this.icollNameForA = icollNameForA;
    }

    public void setIcollNameForB(String icollNameForB) {
        this.icollNameForB = icollNameForB;
    }

    public void setMergeField(String mergeField) {
        this.mergeField = mergeField;
    }
}
